      double complex function ehsva4(s,t,u)
C     ehsv:EqnA.8
      implicit none
      double precision s,t,u
      double complex ehsvb4
      ehsva4=ehsvb4(s,t,u)+ehsvb4(u,s,t)+ehsvb4(t,u,s)
      return 
      end

      double complex function ehsva2(s,t,u)
C     ehsv:EqnA.9
      implicit none
      double precision s,t,u
      double complex ehsvb2
      ehsva2=ehsvb2(s,t,u)+ehsvb2(s,u,t)
      return 
      end

      double complex function ehsvb4(s,t,u)
      implicit none
C     ehsv:EqnA.10
      include 'masses.f'
      double precision hmass2,s,t,u
      double complex w2,w3
      hmass2=hmass**2
      ehsvb4=mbsq/hmass2*(-2d0/3d0
     . +(mbsq/hmass2-0.25d0)*(w2(t)-w2(hmass2)+w3(s,t,u,hmass2)))
      return 
      end

      double complex function ehsvb2(s,t,u)
C     ehsv:EqnA.11
      implicit none
      include 'masses.f'
      double precision hmass2,s,t,u
      double complex w1,w2,w3
      hmass2=hmass**2
      ehsvb2=mbsq/hmass2**2*(s*(u-s)/(s+u)
     . +2d0*u*t*(u+2d0*s)/(s+u)**2*(w1(t)-w1(hmass2))
     . +(mbsq-0.25d0*s)
     . *(0.5d0*w2(s)+0.5d0*w2(hmass2)-w2(t)+w3(s,t,u,hmass2))
     . +s**2*(2d0*mbsq/(s+u)**2-0.5d0/(s+u))*(w2(t)-w2(hmass2))
     . +0.5d0*u*t/s*(w2(hmass2)-2d0*w2(t))
     . +0.125d0*(s-12d0*mbsq-4d0*u*t/s)*w3(t,s,u,hmass2))
      return 
      end

      double complex function ehsva5(s,t,u)
C     ehsv:EqnA.14
      implicit none
      include 'masses.f'
      double precision hmass2,s,t,u
      double complex w1,w2
      hmass2=hmass**2
      ehsva5=mbsq/hmass2*(4d0+4d0*s/(u+t)*(w1(s)-w1(hmass2))
     . +(1d0-4d0*mbsq/(u+t))*(w2(s)-w2(hmass2)))
      return 
      end


      double complex function w1(s)
C     ehsv:EqnA.19
      implicit none
      include 'constants.f'
      include 'masses.f'
      double precision rat,s,temp,acosh,asinh
      rat=4d0*mbsq/s
      temp=sqrt(dabs(1d0/rat))
      if (rat .lt. 0d0) then
          w1=2d0*sqrt(1d0-rat)*asinh(temp)
      elseif (rat .gt. 1d0) then
          w1=2d0*sqrt(rat-1d0)*asin(temp)
      else 
          temp=2d0*acosh(temp)
          w1=sqrt(1-rat)*dcmplx(temp,-pi)
       endif
      return
      end

      double complex function w2(s)
C     ehsv:EqnA.20
      implicit none
      include 'constants.f'
      include 'masses.f'
      double precision rat,s,tempr,tempi,acosh,asinh
      rat=s/(4d0*mbsq)
      tempr=sqrt(dabs(rat))
      if (rat .lt. 0d0) then
          tempr=asinh(tempr)
          w2=4d0*tempr**2
      elseif (rat .gt. 1d0) then
          tempr=acosh(tempr)
          tempi=-4d0*tempr*pi
          tempr=+4d0*tempr**2-pi**2
          w2=dcmplx(tempr,tempi)
      else 
          tempr=asin(tempr)
          w2=-4d0*tempr**2
      endif
      return
      end

      double complex function w3(s,t,u,varg)
C     ehsv:EqnA.17
      implicit none
      double complex i3
      double precision s,t,u,varg
      w3=i3(s,t,u,varg)-i3(s,t,u,s)-i3(s,t,u,u)
      return
      end


      double complex function i3(s,t,u,varg)
C     ehsv:EqnA.21
      implicit none
      include 'constants.f'
      include 'masses.f'
      double precision s,t,u,varg,rat,al,be,ga,r,theta,phi
      double precision arg1,arg2,arg3,arg4,ddilog
      double complex li2,zth,zph
      rat=4d0*mbsq/varg
      if (rat .lt. 0d0) then
           be=0.5d0*(1d0+sqrt(1d0+4d0*t*mbsq/(u*s)))
           ga=0.5d0*(1d0+sqrt(1d0-rat))
           arg1=ga/(ga+be-1d0)
           arg2=(ga-1d0)/(ga+be-1d0)
           arg3=(be-ga)/be
           arg4=(be-ga)/(be-1d0)
           i3=2d0/(2d0*be-1d0)
     .     *(-ddilog(arg1)+ddilog(arg2)+ddilog(arg3)-ddilog(arg4)
     .     +0.5d0*(log(be)**2-log(be-1d0)**2)
     .     +log(ga)*log((ga+be-1d0)/be)
     .     +log(ga-1d0)*log((be-1d0)/(ga+be-1d0)))
      elseif (rat .gt. 1d0) then
           be=0.5d0*(1d0+sqrt(1d0+4d0*t*mbsq/(u*s)))
           al=sqrt(rat-1d0)
           r=sqrt((al**2+1)/(al**2+(2d0*be-1d0)**2))
           phi=acos(r*(al**2+2d0*be-1d0)/(1d0+al**2))
           theta=acos(r*(al**2-2d0*be+1d0)/(1d0+al**2))
           zth=r*dcmplx(cos(theta),sin(theta))
           zph=r*dcmplx(cos(phi),sin(phi))
           i3=2d0/(2d0*be-1d0)
     .     *(2d0*dreal(li2(zth))-2d0*dreal(li2(zph))
     .     +(phi-theta)*(phi+theta-pi))
      else
           be=0.5d0*(1d0+sqrt(1d0+4d0*t*mbsq/(u*s)))
           ga=0.5d0*(1d0+sqrt(1d0-rat))
           arg1=ga/(ga+be-1d0)
           arg2=(ga-1d0)/(ga+be-1d0)
           arg3=ga/(ga-be)
           arg4=(ga-1d0)/(ga-be)
      
           i3=2d0/(2d0*be-1d0)
     .     *(-ddilog(arg1)+ddilog(arg2)+ddilog(arg3)-ddilog(arg4)
     .     +log(ga/(1d0-ga))*log((ga+be-1d0)/(be-ga))
     .     -im*pi*log((ga+be-1d0)/(be-ga)))
      endif

      return
      end

      double precision function acosh(y)
      implicit none
      double precision y      
      acosh=log(y+sqrt(y**2-1d0))
      return
      end

      double precision function asinh(y)
      implicit none
      double precision y      
      asinh=log(y+sqrt(y**2+1d0))
      return
      end

